function ScoreViewerIIDX24_setup(){
	ScoreViewerIIDX24 = {
		title_default: "Score Viewer for beatmania IIDX 24 SINOBUZ",
		URL1: "http://p.eagate.573.jp/game/2dx/24/p/",
		URL2: "http://nobuyukim.cs.land.to/iidx_score/import_ac.php",
		URL3: "http://localhost/iidx_score/import_ac.php",
		URL_official_login: 'p.eagate.573.jp/gate/p/login.html',
		URL_rival: "http://p.eagate.573.jp/game/2dx/24/p/djdata/rival/rival_status.html",
		URL_info: "http://nobuyukim.cs.land.to/addon/ScoreViewerForIIDX24/info.txt",
		URL_vdata: "http://nobuyukim.cs.land.to/addon/ScoreViewerForIIDX24/version.txt",
		URL_vinfo: "http://nobuyukim.cs.land.to/addon/ScoreViewerForIIDX24/vinfo.txt",
		URL_iidxpr: "iidxpr.saryou.jp/tri/dj/editMusic/",
		URL_iidxpr2: "www6111uc.sakura.ne.jp/iidxpr/tri/dj/editMusic/",
		URL_iidxpr_rival:[
			"iidxpr.saryou.jp/tri/dj/data/",
			"iidxpr.saryou.jp/tri/dj/music/",
			"saryou.jp/iidxpr/tri/dj/data/",//旧URL
			"saryou.jp/iidxpr/tri/dj/music/",
			"www6111uc.sakura.ne.jp/iidxpr/tri/dj/data/",
			"www6111uc.sakura.ne.jp/iidxpr/tri/dj/music/"
		],

		sv_prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
//		sv_Branch: sv_prefs.getBranch("extensions.ScoreViewerForIIDX24."),
		sv_Branch: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.ScoreViewerForIIDX24."),
		addon_Branch: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.nob_m-konami."),

		ac_version: 24,
		scoreviewer_version: "",
		data_version: "",
		data_version20: "",
		data_version19: "",
		data_version18: "",

		user_data: "",
		diff_name: "",
		diff_color: "",
		num_rival_view: "",
		music_list: "",
		music_id: "",
		view_list: "",
		rival_data: [],
		rival_top_data: "",
		unofficial_diff: "",

		timerID: "",
		mainTab: "",
		musicTab: "",
		djpTab: "",
		rivalTab: "",
		exTab: "",

		timeout: 30000,

		userLoadData: "",
		readStatus: new Object(),
		musiclist_special: new Object(),
		readTask: "",

		clone: function(obj){
			if(typeof obj === 'undefined'){
				return;
			}
			return JSON.parse(JSON.stringify(obj));
		},

		start_time: '0',

		//version.js
		savedataCheck: "",
		savedataConvert: "",

		//ScoreViewerIIDX24.js
		userDataDefault: "",
		sortMusic: "",
		scoreViewerSetup: "",
		readInfo: "",
		readVersionInfo: "",

		//maintab.js
		webBackup: "",
		setData: "",
		removeData: "",
		getData: "",
		strFullToHalf: "",
		buttonDisable: "",
		iobuttonDisable: "",
		categoryEnable: "",
		categoryDisable: "",
		buttonEnable: "",
		ioButtonEnable: "",
		beginnerLevelExchange: "",
		sortViewList: "",
		writeCategory: "",
		makeFolder: "",
		removeFolderEvent: "",
		addFolderEvent: "",
		changeFolder: "",
		correctMusic: "",
		makeViewList: "",
		writeMultiScore: "",
		writeSingleScore: "",
		searchDani: "",
		searchStepup: "",
		makePageNum: "",
		removePageEvent: "",
		makePageButton: "",
		writeScore: "",
		writeText: "",
		removeMusicEvent: "",
		addMusicEvent: "",
		keepLogin: "",
		viewDjPoint: "",
		editRival: "",
		readImg: "",
		readLampInt: "",
		readRankStr: "",
		readRankInt: "",
		RankStrToInt: "",
		RankIntToStr: "",
		readNextRankScore: "",
		LampIntToStr: "",
		LampStrToInt: "",
		readStr: "",
		readPlayCount: "",
		readScore: "",
		readPgreat: "",
		readGreat: "",
		readMiss: "",
		trim: "",
		readList: "",
		matchWordLine: "",
		iidx_id_Check: "",
		readDjName: "",
		pushTask: "",
		checkTask: "",
		prepareData: "",
		musicRename: "",
		readMusicData: "",
		readMusicData_rival: "",
		GetScore_loop: "",
		GetScore_loop_Top: "",
		readScoreFromChallenge: "",
		readScoreFromCsv: "",
		readFinalAlert: "",
		readCompleteAlert: "",
		setupWindow: "",
		buttonDisableImport: "",
		viewRivalList: "",
		reloadAllRivalHash: "",
		reloadRivalHash: "",
		deleteRivalList: "",
		calcDJPoint: "",
		viewStatus: "",
		rivalDefault: "",
		slotCheck: "",
		selectReset: "",
		rivalViewCheck: "",
		copyData: "",
		readOldData: "",
		resetUserLoadData: "",
		sendUserLoadData: "",

		//musictab.js
		openMusicWindow: "",

		//export.js
		exportScore: "",

		//export_clear_manager.js
		exportClearManager: "",

		//export_fcphp.js
		exportFCPHP: "",

		//export_play_record.js
		id_playrecord: "",
		iidxpr_writeButton: "",
		iidxpr_writeScore: "",
		editRivalPlayRecord: "",

		//export_scoreviewer.js
		crc32: "",
		crc32_fix: "",
		importScoreViewer: "",
		exportScoreViewer: "",
		importScoreViewerSlot: "",
		exportScoreViewerSlot: "",
		margeScoreViewerSlot: "",

		//export_snj-kmzs.js
		importSnjKmzs: "",

		//export_data_analyzer.js
		exportDataAnalyzer: "",

		//export_clearlamp_manager.js
		exportClearLampManager: "",

		//export_katate_ir.js
		exportKatateIR: "",

		//export_abilitysheet.js
		exportAbilitysheet: "",

		//change-id_original-course.js
		changeIdRaToLincle: "",

		//aprilfool.js
		aprilFool: "",
	};

var app = ScoreViewerIIDX24;

//起動時刻
var now_time = new Date();
var now_year = now_time.getFullYear();
var now_month = now_time.getMonth() + 1;
if(now_month < 10){
	now_month = "0" + now_month;
}
var now_date = now_time.getDate();
if(now_date < 10){
	now_date = "0" + now_date;
}
var now_hour = now_time.getHours();
if(now_hour < 10){
	now_hour = "0" + now_hour;
}
var now_min = now_time.getMinutes();
if(now_min < 10){
	now_min = "0" + now_min;
}
app.start_time = now_year + "/" + now_month + "/" + now_date + " " + now_hour + ":" + now_min;

//参考：https://developer.mozilla.org/ja/Code_snippets/Tabbed_browser
window.addEventListener("load",function () {
	gBrowser.addEventListener("load", function(event){
		if(event.originalTarget instanceof HTMLDocument) {
			var doc = event.originalTarget;
			var URL_tmp = doc.URL.replace("https://","http://");
			var tmp = URL_tmp.indexOf("?");
			if(tmp != -1){
				URL_tmp = URL_tmp.slice(0, tmp);
			}
			var tmp = URL_tmp.indexOf("index.html");
			if(tmp != -1){
				URL_tmp = URL_tmp.slice(0, tmp);
			}
			if(URL_tmp.match(app.URL1)){
				if(URL_tmp == app.URL_rival){
					app.editRival(doc);
				}
				var win = event.originalTarget.defaultView;
				if(win.frameElement){
					//do nothing
				}else{
					var elements = doc.getElementsByTagName("body");
					var body = elements[0];
					var div = doc.createElement("div");
					var input = doc.createElement("input");
					input.type = "button";
					input.id = "openScoreViewer";
					input.value = "Score Viewer for beatmania IIDX 24 SINOBUZを起動";
					input.style = "border: 1px solid;";
					input.addEventListener("click", (function(){
						return function(){
							app.scoreViewerSetup();
						};
					})(), false);
					div.insertBefore(input, div.firstChild);
					body.insertBefore(div, body.firstChild);
				}
			//}else if((doc.URL==URL2)||(doc.URL==URL3)){
			//		exportScore(doc);
			}else if((doc.URL.match(app.URL_iidxpr))||(doc.URL.match(app.URL_iidxpr2))){
				app.iidxpr_writeButton(doc);
			}else{
				for(var i=0; i<app.URL_iidxpr_rival.length; i++){
					if(doc.URL.match(app.URL_iidxpr_rival[i])){
						break;
					}
				}
				if(i != app.URL_iidxpr_rival.length){
					app.editRivalPlayRecord(doc);
				}
			}
		}
	}, true);
},false);

}
