(function(){
if(!window.ScoreViewerIIDX24){
	ScoreViewerIIDX24_setup();
}
var app = ScoreViewerIIDX24;

app.exportScore = function (doc){
	var req = new XMLHttpRequest();
	req.open('GET', doc.URL, true);
	req.onreadystatechange = function (aEvt) {
		if(req.readyState == 4) {
			if(req.status == 200){
				var output = "test";
				doc.getElementById("writeButton").innerHTML += "<input type=\"button\" id=\"writeScore\" value=\"AC19のスコアを貼り付け\">";
				doc.getElementById("writeScore").addEventListener("click", (function(){
					return function(){
						if(confirm('Score Viewer for beatmania IIDX 19 Lincleからスコアをロードしますか？\n(読み込み完了までに時間がかかる場合があります。)')){
							for(var i=0; i<doc.forms.namedItem("form1").elements.namedItem("from").length; i++){
								if(doc.forms.namedItem("form1").elements.namedItem("from").options[i].value == "AC19"){
									doc.forms.namedItem("form1").elements.namedItem("from").selectedIndex = i;
								}
							}
							app.getData();
							output = "AC19,\n";
							var note = -1;
							for(var i in app.music_id){
								output += app.music_id[i] + ",";
								for(var j=0; j<6; j++){
									output += app.user_data[0].clear[app.music_id[i]][j] + ",";
									if(app.user_data[0].djlv[app.music_id[i]][j] == -1){
										note = -1;
									}else{
										if(app.user_data[0].djlv[app.music_id[i]][j]==7){
											note = (Number(app.user_data[0].score[app.music_id[i]][j]) + Number(app.user_data[0].next[app.music_id[i]][j])) / 2;
										}else{
											note = Math.floor((Number(app.user_data[0].score[app.music_id[i]][j]) + Number(app.user_data[0].next[app.music_id[i]][j])) * 9 / (app.user_data[0].djlv[app.music_id[i]][j]+2));
											note = Math.floor(note / 2);
										}
									}
									output += note + ",";
									if(app.user_data[0].score[app.music_id[i]][j] == "&nbsp;"){
										app.user_data[0].score[app.music_id[i]][j] = "";
									}
									output += app.user_data[0].score[app.music_id[i]][j] + ",";
									if(app.user_data[0].pgreat[app.music_id[i]][j] == "&nbsp;"){
										app.user_data[0].pgreat[app.music_id[i]][j] = "";
									}
									output += app.user_data[0].pgreat[app.music_id[i]][j] + ",";
									if(app.user_data[0].great[app.music_id[i]][j] == "&nbsp;"){
										app.user_data[0].great[app.music_id[i]][j] = "";
									}
									output += app.user_data[0].great[app.music_id[i]][j] + ",";
									if(app.user_data[0].miss[app.music_id[i]][j] == "&nbsp;"){
										app.user_data[0].miss[app.music_id[i]][j] = "";
									}
									output += app.user_data[0].miss[app.music_id[i]][j] + ",";
								}
								output += "\n";
							}
							doc.forms.namedItem("form1").elements.namedItem("text1").value = output;
						}
					};
				})(), false);
			}
		}
	};
	req.send(null);

	return;
};

})();
